/*global: window, $, jQuery, GLOBAL, data, console*/
GLOBAL = {};
GLOBAL.attempts=0;

(function($) {
	"use strict";
	$.randomize = function(arr) {
		for(var j, x, i = arr.length; i; j = parseInt(Math.random() * i, 10), x = arr[--i], arr[i] = arr[j], arr[j] = x);
		return arr;
	};
})($);

$(document).ready(function(){
	"use strict";
	// Properties of each choice
	// Display choices using data from data.js
	var choices=[];
	if($.isArray(data.choices)) {
		$.each(data.choices, function(key, item) {
			var colour = item.colour ? item.colour : "#FFF";
			var choice_num = key + 1;
			choices.push("<a id=\"choice"+choice_num+"\" style=\"background-color: " + colour + ";\" href=\"javascript:void(0)\" alt=\"\" class=\"choice\" tabindex=\"-1\"><span>"+ item.text+"</span></a>");
		});
	}
	$('body').addClass(data.name); //so CSS can distinguish between different activities
	$('#question').html(data.html);

	//do a quick shuffle
	if(data.randomize === "yes") {
		$.randomize(choices);
	}
	// Display choices using data from data.js
	for (var choice in choices){
		$(".choices").append(choices[choice]);
	}

	$('.choice').draggable( {
		                        containment: '#content',
		                        cursor: 'move',
		                        stack: '.choice',
		                        revert: true
	                        } );
	// Display buttons and set css from data.js
	if($.isArray(data.buttons)) {
		$.each(data.buttons, function(key, item) {
			var button_num = key + 1;
			$(".buttons").append("<div id=\"button_"+button_num+"\" class=\"button\"><input type=\"button\" value=\""+ item.text+"\" tabindex=\""+ (item.tab+data.questions.length) +"\" /></div>");
			$("#button_"+button_num).css("float",item.align);
			var thisScript=item.script;
			$(".buttons #button_"+button_num+" input").click(function(){
				eval(thisScript);
			});
		});
	}
	if($.isArray(data.questions)) {
		$.each(data.questions, function(key, item) {
			var text_num = key + 1;
			var new_html = item.text.replace('---------','<span id=\"droppable-area'+text_num+'\" class=\"choice'+text_num+' droppable\"><a href=\"javascript:void(0);\" tabindex=\"'+text_num+'\"><img src=\"clear-spot.gif\" border=\"0\" /></a></span>');
			$(".targets").append("<span id='text-area-"+text_num+"' class='text-area'>"+new_html+"</span>");
		});
	}


	$(".choice").css("font-size",data.choicefontsize);
	$(".choice").css("color",data.choicetextcolour);
	$(".label").css("font-size",data.labelfontsize);
	$(".label").css("color",data.labeltextcolour);


	//target
	// if class of droppable, then make droppable
	$(".droppable").droppable({
		                          // Event triggered when an accepted draggable(choice) is dropped on the droppable
		                          drop:function(event, ui){
			                          ui.draggable.css({top:"0px",left:"0px"});//lock in place
			                          // Return choice back to choices div if in current target (droppable)
			                          $(".choices").append($(this).find(".choice").css({left:"",top:""}).removeClass("selected"));//chuck out any choices that were already there and put back into top list
			                          // Add draggable html to droppable
			                          $(this).html(ui.draggable);//add to target
		                          }
	                          });

	// If target is clicked (tapped)
	$(".targets span.droppable").click(function(){


		if($(".choices a.selected").length){
			//if one of the choices has been selected by clicking on it
			$(".choices").append($(this).find(".choice").css({left:"",top:""}).removeClass("selected"));//chuck out
			// Add html of the 'selected' choice in the list at the top
			$(this).html($(".choices a.selected"));//append
			// otherwise we'll put in first of the choices
		} else if($(this).hasClass("selected")){
			var tabNum = $(this).parent().index()+1;

			if ($(".choices a").length === 0) {// if all targets have been filled by choices a tags
				$(".choices").append($(this).find(".choice").css({left:"",top:""}).removeClass("selected"));//chuck out
				var newString="<a href=\"javascript:void(0);\" tabindex=\""+tabNum+"\">< src=\"clear-spot.gif\" border=\"0\" /></a>";
				$(this).html(newString);
			} else { //there are still targets to be filled
				$(".choices").append($(this).find(".choice").css({left:"",top:""}).removeClass("selected"));//chuck out (cant put before condition test so must be repeated)
				// select first of the items from the choices
				$(this).html($(".choices a").eq(0));
				$(this).find('a').attr("tabindex",tabNum);
			}
			$(".choices a").attr("tabindex","-1"); //we dont wont these gaining a tab index
		}
		$(".targets span.droppable").removeClass("selected");
		$(this).addClass("selected");
		$(this).find("a").focus();
	});
	// Add 'selected' to choice selected
	$(".choices a").click(function(){
		if($(this).hasClass("selected")){
			$(".choices a").removeClass("selected");
		}else{
			$(".choices a").removeClass("selected");
			$(this).addClass("selected");
			$(this).focus();
		}
	});
	$(".targets span.droppable").focusin(function(){
		//  $(".targets div span").removeClass("selected");
		$("#content").addClass("targeting");
	});
	$(".targets span.droppable").focusout(function(){
		$("#content").removeClass("targeting");
	});
});

function checkAnswer() {
	"use strict";
	GLOBAL.attempts++;
	var correctResponses=0;
	var numOfQuestions=0;
	if($.isArray(data.questions)) {
		$.each(data.questions, function(key, item) {
			var text_num = key + 1;
			var userAttempt = $("#text-area-"+text_num+" span a").text();
			var correctAnswerArray= new Array();
			$.each(item.answers, function(i, answer) {
				correctAnswerArray.push(answer.text);
			});
			if (jQuery.inArray(userAttempt, correctAnswerArray) !== -1) {correctResponses++;}
			numOfQuestions++;
		});
	}
	if (correctResponses === numOfQuestions) {
		revealAnswer();
		$(".feedback-area").html("Your answer is correct."+ data.extraFeedback);
	} else {
		if (GLOBAL.attempts === 1) {
			$(".feedback-area").html('Your answer is incorrect, you have scored '+correctResponses +' out of ' +  numOfQuestions +'.<br/><br/>Please try again.');

		} else if (GLOBAL.attempts === 2) {
			$(".feedback-area").html('Your answer is still incorrect, you have scored '+correctResponses +' out of ' +  numOfQuestions +'.<br/><br/>Please try again.');

		} else {
			revealAnswer();
			$(".feedback-area").html('Your answer was still incorrect, the correct answer is shown.' + data.extraFeedback);
		}
	}
}

function revealAnswer() {
	"use strict";
	if($.isArray(data.questions)) {
		$.each(data.questions, function(key, item) {
			var text_num = key + 1;
			$(".targets #text-area-"+text_num+" span").html("<a id=\"choice"+text_num+"\" class='answered'><span>"+ item.answers[0].text+"</span></a>");
			$(".targets #text-area-"+text_num+" span").removeClass("droppable");
		});
		$(".choices").html(" ");
	}
	$("#button_2 input").attr('disabled','disabled');
	$("#button_3 input").attr('disabled','disabled');

	$(".targets span.droppable").removeClass("selected");
	$(".targets span").unbind(); //unbind all handlers to disable interactivity
	$(".feedback-area").html('The correct answer is shown.' + data.extraFeedback);
}